$fn = 30;

module roundedRect(size, radius,height)
{
	x = size[0]-radius;
	y = size[1]-radius;
   linear_extrude(height)
	hull()
	{
		// place 4 circles in the corners, with the given radius
		translate([(-x/2)+(radius/2), (-y/2)+(radius/2), 0])
		circle(r=radius);
		
		translate([(x/2)-(radius/2), (-y/2)+(radius/2), 0])
		circle(r=radius);
		
		translate([(-x/2)+(radius/2), (y/2)-(radius/2), 0])
		circle(r=radius);
		
		translate([(x/2)-(radius/2), (y/2)-(radius/2), 0])
		circle(r=radius);
	}
}

module notroundedRect(size, radius,height)
{
	x = size[0]-radius;
	y = size[1]-radius;
   linear_extrude(height)
	hull()
	{
		// place 4 circles in the corners, with the given radius
		translate([(-x/2)+(radius/2)-5, (-y/2)+(radius/2), 0])
		circle(r=radius);
		
		translate([(x/2)-(radius/2)-5, (-y/2)+(radius/2), 0])
		circle(r=radius);
		
		translate([(-x/2)+(radius/2), (y/2)-(radius/2), 0])
		circle(r=radius);
		
		translate([(x/2)-(radius/2), (y/2)-(radius/2), 0])
		circle(r=radius);
	}
}

module standoffhole() {
	  cylinder(h=28.5,r=2.0/2, center=true);
}

module standoff() {
	  cylinder(h=28.5,r=5/2, center=true);
}

module box() {
  union()
  { 
    roundedRect([46.75-3.0,93.25-2,13],4.0,2);  //outside box face 
    difference() {
 	  roundedRect([46.75-3,93.25-2,13],4.0,10);  //outside box
  	  roundedRect([46.75-6.64,93.25+1-6.64,13],2.5,10.1);  //inside box  // was 2.64 thick
    }
  }
}


module lcdbox() {
difference() {
  union() {  
//    box();
    translate([-31/2,-75/2 -0.2 ,2+5.5/2]) standoff();
    translate([-31/2,+75/2 -0.2 + 0.8,2+5.5/2]) standoff();
    translate([+31/2 +0.9,+75/2 -0.2 + 0.8,2+5.5/2]) standoff();
    translate([+31/2 +0.9,-75/2 -0.2 ,2+5.5/2]) standoff();
  }
  union() {
    cube([27.5,72.5,5],center=true);  //cutout lcd window
    translate([-31/2,-75/2 -0.2 ,2+5.5/2]) standoffhole();  
    translate([-31/2,+75/2 -0.2 + 0.8,2+5.5/2]) standoffhole();
    translate([+31/2 +0.9,+75/2 -0.2 + 0.8,2+5.5/2]) standoffhole();
    translate([+31/2 +0.9,-75/2 -0.2 ,2+5.5/2]) standoffhole();  
  }
}
}

module snap() {
   difference() {
       
     union() { 
       cube([10,4,12.5]);
       rotate([-30,0,0]) translate([0,-5,6]) cube([10,3,5.7]);
     }
     union() {  
      rotate([-30,0,0]) translate([-0.1,-8,5]) cube([10.2,3,6.7]);
      translate([-0.1,-3,1]) cube([10.2,3,6.7]);           
     }
   }
}


module rotary() {
    translate([-60+3-10,-5 -5 -3,0]) cylinder(r=3.7,h=5);    // rotary encoder shaft 3.7
    translate([-60 -13/2 +3-10 , -5 - 16/2 -5 -3,2])  cube([13,16,3]);    // rotary encoder square
    #translate([-60-8, -8 ,1]) cube([2,3,3]);    // rotary encoder square
}

module makeit() {

difference() {
    notroundedRect([162,58],8,4);
    union() {
    translate([30,3-4,0]) rotate([0,0,90]) cube([36.5,72.5,9],center=true);  //lcd
    translate([30,20.7+0.8,4]) rotate([0,0,90]) cube([7,72.5+10,4],center=true);  //lcd     

    rotary();
    translate([-36,0,0]) cylinder(r=29.4/2,h=5);    // USB hole    29.4, 36.7    
    }
}
 


translate([56,28.8,3]) rotate([6,0,180]) snap();
translate([-45,28.8,3]) rotate([6,0,180]) snap();
rotate([-6,0,0]) translate([39,-28.8+1,0]) snap();
rotate([-6,0,0]) translate([-64,-28.8+1,0]) snap(); 
}

module finalbox() {

makeit();

difference() {
  union() {
  translate([30,-3,0]) rotate([0,40,90]) lcdbox();
  difference() {    
    translate([-7.5,0.5,4]) rotate([50,0,0]) cube([2,24.3,28.5],center=true);  //sides
    translate([-7.5,8,12.5]) rotate([50,0,0]) cube([2,2.2,16],center=true);  //sides  
  }    
  translate([67.5,0.5,4]) rotate([50,0,0]) cube([2,24.3,28.5],center=true);  //sides
  translate([30,-12,13.2]) rotate([-40,0,0]) cube([72,2,26],center=true);  //sides      
  translate([30,20.7-2.3,3]) rotate([0,0,90]) cube([2,72.5+10,2],center=true); // small bar
  
  }
  translate([30,0,-20/2]) cube([92,50,20],center=true);  
}

}

//intersection() {
finalbox();
//   translate([-57,12,0]) cube([30,30,8],center=true);
